<?php
/*
Template Name: Login Page
*/

global $tpl;

gk_load('header');
gk_load('before');

?>

<div id="gk-mainbody" class="loginpage">
	<?php the_post(); ?>
	
	<h1 class="page-title"><?php the_title(); ?></h1>
	
	<article>
		<div class="intro">
			<?php the_content(); ?>
		</div>
		
		<?php if ( is_user_logged_in() ) : ?>
			<?php 
				
				global $current_user;
				get_currentuserinfo();
			
			?>
			
			<p>
				<?php echo __('سلام, ', GKTPLNAME) . ($current_user->user_firstname) . ' ' . ($current_user->user_lastname) . ' (' . ($current_user->user_login) . ') '; ?>
				 <a href="<?php echo wp_logout_url(); ?>" title="<?php _e('خروج', GKTPLNAME); ?>">
					 <?php _e('خروج', GKTPLNAME); ?>
				 </a>
			</p>
		
		<?php else : ?>
		    
			<?php 
				wp_login_form(
					array(
						'echo' => true,
						'form_id' => 'loginform',
						'label_username' => __( 'نام کاربری', GKTPLNAME ),
						'label_password' => __( 'کلمه عبور', GKTPLNAME ),
						'label_remember' => __( 'مرا به خاطر بسپار', GKTPLNAME ),
						'label_log_in' => __( 'ورود', GKTPLNAME ),
						'id_username' => 'user_login',
						'id_password' => 'user_pass',
						'id_remember' => 'rememberme',
						'id_submit' => 'wp-submit',
						'remember' => true,
						'value_username' => NULL,
						'value_remember' => false 
					)
				); 
			?>
			
			<nav class="small">
				<ul>
					<li>
						<a href="<?php echo home_url(); ?>/wp-login.php?action=lostpassword" title="<?php _e('بازیابی رمز عبور', GKTPLNAME); ?>"><?php _e('رمز عبور را فراموش کرده اید?', GKTPLNAME); ?></a>
					</li>
					<li>
						<a href="<?php echo home_url(); ?>/wp-login.php?action=register" title="<?php _e('هنوز ثبت نام نکرده اید؟', GKTPLNAME); ?>"><?php _e('عضویت', GKTPLNAME); ?></a>
					</li>
				</ul>
			</nav>
		
		<?php endif; ?>
	
	</article>
</div>

<?php

gk_load('after');
gk_load('footer');

// EOF